/* Console Csound using the Csound API. */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <csound/csound.h>

#if defined HAVE_FLTK
#include <FL/Fl.H>

namespace {
  int yield(void *data)
  {
    Fl::check();
    return 1;
  }
}
#endif

int main(int argc, char **argv)
{
  void *csound;
  int rc;

  /* set stdout to non buffering if not outputting to console window */
  if(!isatty(fileno(stdout))) {
    setvbuf(stdout, (char *)NULL, _IONBF, 0);
  }

  csound = csoundCreate(0);
#if defined HAVE_FLTK
  csoundSetYieldCallback(csound, yield);
#endif
  rc = csoundPerform(csound, argc, argv);
  csoundCleanup(csound);
  csoundReset(csound);
  csoundDestroy(csound);
  return rc;
}
